
//DroidScript extension util class.
function Extension()
{
    var self = this;
    this.serverIP = "";      //DS ip.
    this.appName = "";       //Current loaded app name.
    
    //Hook into cross frame messaging
    window.addEventListener("message", function(event) 
    {
    	var params = event.data.split("|");
    	var cmd = params[0];
    	console.log( "ext msg:" + event.data );
    	
    	if( cmd=="init" ) { 
    	    self.serverIP = params[1];
    	    self.appName = params[2];
    	    if(typeof ext_OnReady=='function') ext_OnReady();
    	}
    	else if( cmd=="onSelect" ) 
    	{
    	    self.appName = params[2];
    	    if( typeof ext_OnSelect=='function' ) ext_OnSelect(params[1]);
    	}
    	else if( cmd=="onDeselect" ) 
    	    if( typeof ext_OnDeselect=='function') ext_OnDeselect(params[1]);
    });

    //Initialise the extension.
    this.Init = function()
    {
        //Ask for initialisation data.
    	parent.postMessage( "init:", "*" )
    }
    
    //Send message to IDE console.
    this.Log = function( msg )
    {
    	if( parent ) parent.postMessage( "log:"+msg, "*" )
    }
    
	//Execute code on the device.
	//'app' mode runs as a stand-alone app.
	//'ide' mode runs inside ide.
	//'usr' mode runs inside current user app.
	this.Execute = function( mode, code ) 
	{ 
		xmlHttp = new XMLHttpRequest();
		xmlHttp.open( "get", "/ide?cmd=execute&mode="+mode+"&code="+encodeURIComponent(btoa(code)), true );
		xmlHttp.send();
	}
		
	//Execute shell commands with output is shown in debug tab.
	//(Same as typing into WiFi IDE debug tab)
	this.SysExec = function( code ) 
	{ 
		xmlHttp = new XMLHttpRequest();
		xmlHttp.open( "get", "/ide?cmd=exec&code=" + encodeURIComponent("$"+code), true );
		xmlHttp.send();
	}
	
	//Get the ip address of the DroidScript server.
	this.GetServerIp = function()
	{
	    return self.serverIP; 
	}
	
	//Reload a given file.
	//Use '*' to reload all current editor files.
    this.Reload = function( fileName )
    {
        //Ask for initialisation data.
    	parent.postMessage( "reload:"+fileName, "*" )
    }
    
    //Refresh the app list.
    this.Refresh = function()
    {
    	parent.postMessage( "refresh:", "*" )
    }
}

//Create single global instance.
var ext = new Extension();

